<?php

class Payzoff_Mygateway_PaymentController extends Mage_Core_Controller_Front_Action
{
    public function resultAction()
    {
        $helper = Mage::helper( 'mygateway/data' );

        $data = $_POST; //$this->getRequest()->getParams();
        /*
        $data   = Array(
            'transaction_id'        => '8274509547010',
            'amount'                => '0.01',
            'create_date'           => 1453147229,
            'transaction_status'    => 'Complete',
            'paid_amount'           => 0.01,
            'secret_code'           => '6SEP2SajadGfpJT23WdTvmaNHZu44pPfwOl8woWR',
            'seller_transaction_id' => '33',
            'fee'                   => 0,
            'payment_hash'          => 'fc77689c2bdc0316595fa8fd7d151454'
        );
        */

        if ( $helper->validate_transaction( $data ) )
        {

            $quoteId = $data['seller_transaction_id'];
            $order   = Mage::getModel( 'sales/order' )->loadByAttribute( 'quote_id', $quoteId );
            $order->setState( Mage_Sales_Model_Order::STATE_PAYMENT_REVIEW, true, 'Payment Success.' );
            $order->save();

            Mage::getSingleton( 'checkout/session' )->unsQuoteId();
            Mage_Core_Controller_Varien_Action::_redirect( 'checkout/onepage/success', array( '_secure' => false ) );
        }
        else
        {
            Mage_Core_Controller_Varien_Action::_redirect( 'checkout/onepage/error', array( '_secure' => false ) );
        }
    }

    public function returnAction()
    {
        Mage_Core_Controller_Varien_Action::_redirect( 'checkout/onepage/success', array( '_secure' => false ) );
    }

    public function failAction()
    {
        Mage_Core_Controller_Varien_Action::_redirect( 'checkout/onepage/error', array( '_secure' => false ) );
    }

}